<template>
    <div class="text-center mt-1">
        <div class="update-zip-text-link">
            <textLink
                id="serviceZipLinkPromptId"
                linkType="text"
                :text="serviceZipLinkText"
                href="#!"
                @clickEvent="openModal" />
        </div>
    </div>
    <modal
        :ref="modalName"
        :headerText="modalHeaderText"
        :onModalOpenedCallback="onModalOpened"
        :onModalClosedCallback="onModalClosed"
        :footerButtonText="modalFooterText"
        :modalPosition="'center'"
        @footerButtonEvent="setZipCode">
        <serviceZipQuestion
            ref="serviceZipCodeQuestion"
            v-model="internalModel.zipCode"
            customInputId="serviceZipCode"
            :cmsWidgetName="textboxQuestionWidgetName"
            v-on="{ 'textboxQuestionEvent.inputIdAssigned': onInputIdAssigned }" />
        <alert
            v-if="displayInvalidZipAlert"
            ref="alertInvalidZip"
            class="my-4"
            :cmsWidgetName="alertInvalidZipWidgetName"
            alertClass="alert-danger"
            :isDismissible="false" />
    </modal>
</template>

<script>
import textLink from '@/ux-components/text-link/text-link.vue';
import serviceZipQuestion from '@/layouts/service-location/service-zip-modal-question/service-zip-question/service-zip-question.vue';
import modal from '@/digital-components/modal/modal.vue';
import alert from '@/ux-components/alert/alert.vue';

import { getServiceabilityDetails, getZipCodeData } from '@/helpers/service-location-helper';

export default {
    name: 'service-zip-modal-question',
    components: {
        textLink,
        modal,
        serviceZipQuestion,
        alert
    },
    props: {
        modelValue: {
            type: Object,
            default: () => ({
                state: '',
                zipCode: ''
            })
        },
        modalWidgetName: String,
        onZipUpdateCallback: {
            type: Function
        }
    },
    emits: ['update:modelValue', 'updated-serviceability', 'updated-contains-military-base'],
    setup() {
        const textboxQuestionWidgetName = 'ServiceZipQuestionWidget';
        const alertInvalidZipWidgetName = 'AlertInvalidZipWidget';
        return {
            textboxQuestionWidgetName,
            alertInvalidZipWidgetName
        };
    },
    data() {
        return {
            internalModel: this.copyModel(this.modelValue),
            serviceZipCodeTextInputId: '',
            displayInvalidZipAlert: false
        };
    },
    computed: {
        serviceZipLinkText() {
            if (this.modelValue.zipCode && this.modelValue.zipCode.length > 0) {
                return `${this.modelValue.state}, ${this.modelValue.zipCode}`;
            }
            return null;
        },
        modalHeaderText() {
            return this.getCmsContent(this.textboxQuestionWidgetName, 'QuestionText');
        },
        modalFooterText() {
            return this.getCmsContent(this.modalWidgetName, 'FooterText');
        },
        modalName() {
            return this.modalWidgetName;
        }
    },
    watch: {
        modelValue(newValue) {
            this.internalModel = this.copyModel(newValue);
        },
        'internalModel.zipCode': {
            handler() {
                this.resetsOnZipInput();
            }
        }
    },
    methods: {
        resetAlerts() {
            this.displayInvalidZipAlert = false;
        },
        resetsOnZipInput() {
            this.resetAlerts();
        },
        focusOnZipInput() {
            const input = document.getElementById(this.serviceZipCodeTextInputId);
            input?.focus();
        },
        copyModel(modelToCopy) {
            return {
                state: modelToCopy.state,
                zipCode: modelToCopy.zipCode
            };
        },
        openModal() {
            this.$refs[this.modalName].openModal();
        },
        closeModal() {
            this.$refs[this.modalName].closeModal();
        },
        onInputIdAssigned(inputId) {
            this.serviceZipCodeTextInputId = inputId;
        },
        onModalOpened() {
            this.internalModel.zipCode = this.modelValue.zipCode;
            this.focusOnZipInput();
        },
        onModalClosed() {
            this.internalModel.zipCode = this.modelValue.zipCode;
            this.resetsOnZipInput();
        },
        async setZipCode() {
            if (this.internalModel.zipCode !== this.modelValue.zipCode) {
                this.resetAlerts();

                const zipCodeData = await getZipCodeData(this.internalModel.zipCode);

                if (!zipCodeData.isValid) {
                    this.displayInvalidZipAlert = true;
                    this.focusOnZipInput();
                } else {
                    this.internalModel.state = zipCodeData.state;
                    const serviceZipCode = this.internalModel.zipCode;

                    // retrieve serviceability details
                    const serviceabilityDetails = await getServiceabilityDetails(serviceZipCode);

                    // update content related to service zip code
                    this.$emit('updated-serviceability', serviceabilityDetails.data);
                    this.$emit('updated-contains-military-base', zipCodeData.containsMilitaryBase);

                    // Update the page level model
                    this.$emit('update:modelValue', this.internalModel);
                    if (this.onZipUpdateCallback) {
                        await this.onZipUpdateCallback(serviceZipCode);
                    }

                    this.closeModal();
                }
            } else {
                this.closeModal();
            }
        },
        getZipCodeData
    }
};
</script>

<style lang="scss" scoped>
a#serviceZipLinkPromptId {
    line-height: 26px;
}

.update-zip-text-link::before {
    content: "";
    display: inline-block;
    width: 13px;
    height: 16px;
    background-image: url("data:image/svg+xml,%3Csvg viewBox='0 0 13 16' fill='none' xmlns='http://www.w3.org/2000/svg'%3E%3Cpath d='M6.49635 1.00142e-07C5.64734 -0.000153295 4.80722 0.175918 4.0274 0.517444C3.24757 0.858969 2.54443 1.35877 1.96099 1.98626C0.765713 3.27588 0.0999756 4.98141 0.0999756 6.75394C0.0999756 8.52646 0.765713 10.232 1.96099 11.5216L5.98324 15.777C6.04954 15.8475 6.12918 15.9036 6.21736 15.9419C6.30555 15.9802 6.40045 16 6.49635 16C6.59225 16 6.68716 15.9802 6.77534 15.9419C6.86353 15.9036 6.94317 15.8475 7.00946 15.777L11.0317 11.52C12.2391 10.2383 12.909 8.52914 12.8999 6.75394C12.9094 4.97818 12.2394 3.26832 11.0317 1.98626C10.4481 1.35899 9.74493 0.859347 8.96514 0.517839C8.18535 0.176331 7.34532 0.000130509 6.49635 1.00142e-07V1.00142e-07ZM6.49635 9.13131C6.02507 9.13131 5.56437 8.98913 5.17251 8.72275C4.78065 8.45637 4.47524 8.07776 4.29488 7.63479C4.11453 7.19181 4.06734 6.70438 4.15928 6.23412C4.25123 5.76387 4.47817 5.33191 4.81142 4.99287C5.14467 4.65384 5.56925 4.42295 6.03148 4.32941C6.49371 4.23587 6.97282 4.28388 7.40823 4.46736C7.84364 4.65085 8.21579 4.96157 8.47762 5.36023C8.73945 5.7589 8.87921 6.2276 8.87921 6.70707C8.87921 7.34974 8.62837 7.96611 8.18185 8.4207C7.73532 8.87528 7.12964 9.13088 6.49794 9.13131H6.49635Z' fill='%231574A1'/%3E%3C/svg%3E%0A");
    background-size: contain;
    vertical-align: middle;
    margin-right: 0.5em;
}
</style>
